import PyCara.PyCaraExport as PyCaraExport
import argparse
import sys
import os


# #######################################
# Write 3d face data to standard output in a simple format 
# frame_index point_name x y z 
#

parser = argparse.ArgumentParser()
parser.add_argument('filename', help='filename', nargs='?')
args = parser.parse_args()

filename = args.filename
if filename == None:
    print "Must supply a filename"
    sys.exit(1)

cara = PyCaraExport.CaraExport()
if not cara.open( filename ):
    print "failed to open cara file [{}]".format(filename)
    sys.exit(1)

# first build a dict mapping point_id to point name
# note that names only include face points 
names = dict()
for point_id in cara.face_points():
    point_name = cara.point_name(point_id)
    if point_name == "":
        point_name = "point_{}".format( point_id )
    names[point_id] = point_name
    
for frame_index in xrange(cara.n_frames()):

    # obtain all points and their 3d data for this frame 
    data = cara.points_and_3d_for_frame( frame_index )
    
    for (point_id,X) in data.iteritems():
        # check that the point_id has name (and is therefore a face point)
        if names.has_key(point_id):
            print "{0}\t{1:<30}{2[0]}\t{2[1]}\t{2[2]}".format( frame_index, names[point_id], X )
    
sys.exit(0)
