import PyCara.PyCaraExport as PyCaraExport
from PyCara.PyDebugServices import *
import sys
import os
import argparse

set_global_log_level(0)

def succeeded( ok ):
    if ok:
        return "succeeded"
    return "failed"


#########################################
# Demonstrate how to query a Cara file  
#

# Create an instance of the Cara processing engine
cara = PyCaraExport.CaraExport()

parser = argparse.ArgumentParser()
parser.add_argument('filename', help='filename', nargs='?' )
args = parser.parse_args()
filename = args.filename

if filename == None:
    print "Must supply a filename"
    sys.exit(1)



# Open a solved Cara project file
if not cara.open( filename ):
    print "failed to open cara file [{}]".format(filename)
    sys.exit(1)

# Obtain the frame rate of the capture and the timecode standard 
print "frame rate (Hz) [{}]".format(cara.frame_rate())
print "timecode standard [{}]".format(cara.timecode_standard())


# want to convert between timecode, burn-in and zero-based indices


# For the first 10 frames of the sequence, output the frame index, the timecode as a string, 
# and a tuple containing the timecode information

def format_timecode(timecode):
    return "{:0>2}:{:0>2}:{:0>2}:{:0>2}+{:0>2}".format( timecode[0], timecode[1], timecode[2], timecode[3], int(timecode[4]*100) )


print "index\tburn-in\ttimecode"
for index in xrange(10):

    timecode = cara.timecode_from_index( index )
    burn_in = cara.burn_in_from_index( index )
    
    print "{}\t{}\t{}".format( index, burn_in, format_timecode(timecode) )
